/////////////////////////////////////////////
//Klasse: Token
//Autor: Philipp Meiner
//Datum: 11.Dez.2012
////////////////////////////////////////////
//Beschreibung und Benutzungshinweise sind in der Header Datei.


#include "token.h"
//#include <QDebug>

Token::Token(TokenType *TypePtr, QGraphicsScene* scene)
: m_TokenTypePtr(TypePtr), m_Row(0),m_Column(0),m_MovePercent(0),m_MoveTargetRow(0),m_MoveTargetColumn(0)
{
  scene->addItem(this);
  this->setZValue(m_TokenTypePtr->Layer);
}

Token::~Token()
{
  if(this->scene()){
    this->scene()->removeItem(this);
  }
}

void Token::LoadImageScaled(qreal width, qreal height)
{
  if(m_TokenTypePtr->ImagePtr != 0){
    this->setPixmap(QPixmap::fromImage(*(m_TokenTypePtr->ImagePtr)).scaled(width*m_TokenTypePtr->ScaleFactor, height*m_TokenTypePtr->ScaleFactor, Qt::KeepAspectRatio,Qt::SmoothTransformation));
  }
}

void Token::CenterAtPos(QPoint Pos)
{
  ((QGraphicsPixmapItem*)this)->setPos(Pos.x() - this->pixmap().width()/2, Pos.y() - this->pixmap().height()/2 );
}

void Token::PlaceScaledInRectClean(QRect Rect)
{
    LoadImageScaled(Rect.width(), Rect.height());
    CenterAtPos(Rect.center());
}

void Token::PlaceScaledInRectFast(QRect Rect)
{
  if(!(this->pixmap().isNull())){
    setPixmap(this->pixmap().scaled(Rect.width()*m_TokenTypePtr->ScaleFactor,Rect.height()*m_TokenTypePtr->ScaleFactor, Qt::KeepAspectRatio,Qt::SmoothTransformation));
    CenterAtPos(Rect.center());
  }
}

int Token::Type() const
{
  if(m_TokenTypePtr == 0){return -1;}
  return m_TokenTypePtr->ID;
}

int Token::Player() const
{
  if(m_TokenTypePtr == 0){return -1;}
  return m_TokenTypePtr->Player;
}

void Token::setType(TokenType * Type) {
  if(Type != 0){
    m_TokenTypePtr = Type;
    this->setZValue(m_TokenTypePtr->Layer);//Layer des Grafikobjekts direkt auf den den neuen Typs setzten
  }
}
